SystemOrganization addCategory: #'CS528-Project'!

WAComponent subclass: #BetButton
	instanceVariableNames: 'betAmount betCallback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project'!

!BetButton class methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/14/2013 20:31'!
onBet: aCallback
	^(self new onBet: aCallback).! !

!BetButton methodsFor: 'rendering' stamp: 'BrianDentino 7/14/2013 20:31'!
onBet: aCallback
	betCallback := aCallback.! !

!BetButton methodsFor: 'rendering' stamp: 'BrianDentino 7/15/2013 20:15'!
renderContentOn: html
	| id |
	id := html nextId.
	html div
		id: id;
		script: (html jQuery new dialog
			title: 'Enter Amount';
			resizable: false;
			modal: true;
			autoOpen: false);
		with: [ html text: 'hello' ].
	
	html span
		with: [  
		
			html div script: (html jQuery new slider
				value: betAmount;
				onChange: (html jQuery ajax
					callback: [ :value | betAmount := value asNumber ]
					value: (html jQuery this slider getValue))).
			
			html submitButton 
				onClick: ( html jQuery ajax
					callback: [ betCallback value: betAmount ] );
				with: 'Bet'.
		].! !

WAComponent subclass: #PokerPlayer
	instanceVariableNames: 'playerID tableID table browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project'!

PokerPlayer class
	instanceVariableNames: 'nextID'!

!PokerPlayer commentStamp: '<historical>' prior: 0!
A PokerPlayer is a Seaside component that manages client decisions. When the state of a game changes, the PokerPlayer class notifies the view via a websocket connection to the browser.

Instance Variables
!

PokerPlayer class
	instanceVariableNames: 'nextID'!

!PokerPlayer class methodsFor: 'initialize' stamp: 'BrianDentino 7/12/2013 02:13'!
initialize 
	super initialize.
	nextID := 0.! !

!PokerPlayer class methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/12/2013 02:17'!
nextID
	nextID := nextID + 1.
	^ nextID asString.! !

!PokerPlayer class methodsFor: 'initialize' stamp: 'BrianDentino 7/12/2013 02:15'!
tableID: table
	^(self new tableID: table playerID: PokerPlayer nextID)! !

!PokerPlayer methodsFor: 'accessing' stamp: 'BrianDentino 7/12/2013 01:47'!
close
	table close.! !

!PokerPlayer methodsFor: 'as yet unclassified' stamp: 'lb 7/12/2013 15:21'!
initialize 
	super initialize.
	browser := BrowserWebsocket delegate: self.! !

!PokerPlayer methodsFor: 'accessing' stamp: 'lb 7/12/2013 16:26'!
onMessage: aMessage from: websocket
	(websocket == table) ifTrue: [ browser sendMessage: aMessage ].
	(websocket == browser) ifTrue: [ table sendMessage: aMessage ].! !

!PokerPlayer methodsFor: 'rendering' stamp: 'BrianDentino 7/14/2013 20:23'!
placeBet: anAmount 
	self halt.! !

!PokerPlayer methodsFor: 'accessing' stamp: 'lb 7/13/2013 15:16'!
playerID
	^ playerID! !

!PokerPlayer methodsFor: 'rendering' stamp: 'BrianDentino 7/14/2013 20:30'!
renderContentOn: html
	html text: 'Welcome to table ', tableID.
	html horizontalRule.
	
	html render: (BetButton onBet: [ :betAmount | self placeBet: betAmount ]).
	html horizontalRule.
	
	html heading level: 2; with: 'Players:'.
	html div id: 'players'.
	
	html heading level: 2; with: 'Cards'.
	html div id: 'cards'.
	
	html render: (TestJSComponent wsAddress: 'ws://localhost:1701/', tableID, '_', playerID).! !

!PokerPlayer methodsFor: 'accessing' stamp: 'lb 7/13/2013 14:03'!
sayHello

	| msg |
	msg := WebsocketMessage id: 'cards' content: 'Hello!!!!!!'.
	table sendMessage: msg json! !

!PokerPlayer methodsFor: 'accessing' stamp: 'BrianDentino 7/6/2013 21:29'!
tableID
	^tableID! !

!PokerPlayer methodsFor: 'accessing' stamp: 'lb 7/13/2013 15:24'!
tableID:  aTableID playerID: aPlayerID
	| url |
	tableID := aTableID.
	playerID := aPlayerID.
	url := tableID, '_', playerID.
	table := TableWebsocket tableID: tableID delegate: self.
	
	ZnServer default delegate map: url to: (ZnWebSocketDelegate map: url to: browser).
	
	"table sendMessage: (WebsocketMessage id: 'Joining' content: aPlayerID) json  -->  not sending msg till websocket connects now"! !

WAComponent subclass: #PokerPlayerJS
	instanceVariableNames: 'tableID tableConnection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project'!

!PokerPlayerJS commentStamp: '<historical>' prior: 0!
A PokerPlayerJS is a mock of PokerPlayer with websocket connections running in the browser instead of the client component.

Instance Variables
	tableConnection:		<Object>
	tableID:		<Object>

tableConnection
	- xxxxx

tableID
	- xxxxx
!

!PokerPlayerJS class methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/7/2013 00:09'!
clientHtml
	^ '<!!DOCTYPE html>
<meta charset="utf-8" />
<title>WebSocket Chatroom</title>

<script language="javascript" type="text/javascript">

  var wsUri = "ws://" + location.host + "/ws-chatroom";
  var websocket;
  var output, handleInput, messageInput, sendButton, closeButton;

  function init() {
    output = document.getElementById("output");
    handleInput = document.getElementById("handleInput");
    messageInput = document.getElementById("messageInput");
    sendButton = document.getElementById("sendButton");
    closeButton = document.getElementById("closeButton");
    handleInput.value = "user-" + (new Date()).getMilliseconds();
    messageInput.onkeyup = function (evt) { if (evt.keyCode == 13) sendChatMessage(evt) }
    sendButton.onclick = function (evt) { sendChatMessage(evt) };
    closeButton.onclick = function (evt) { closeChat(evt) };
    testWebSocket();
  }

  function testWebSocket() {
    writeToScreen(wsUri);
    websocket = new WebSocket(wsUri);
    websocket.onopen = function(evt) { onOpen(evt) };
    websocket.onclose = function(evt) { onClose(evt) };
    websocket.onmessage = function(evt) { onMessage(evt) };
    websocket.onerror = function(evt) { onError(evt) };
  }

  function onOpen(evt) {
    writeToScreen("CONNECTED");
    doSend("Hi there !!");
  }

  function onClose(evt) {
    writeToScreen("DISCONNECTED");
  }

  function onMessage(evt) {
    writeToScreen(evt.data);
   }

  function onError(evt) {
    writeToScreen("<span style=''color: red''>ERROR:</span> " + evt.data);
  }

  function doSend(message) {
     websocket.send(handleInput.value + ">>" + message);
  }

  function writeToScreen(message) {
    var pre = document.createElement("p");
    pre.style.wordWrap = "break-word";
    pre.innerHTML = message;
    output.appendChild(pre);
  }

  function sendChatMessage(evt) {
    doSend(messageInput.value);
    messageInput.value = "";
  }

  function closeChat(evt) {
    doSend("Bye!!");
    websocket.close();
  }

  window.addEventListener("load", init, false);

</script>

<h2>WebSocket Chatroom</h2>
<div>
Handle: <input id="handleInput" type="text"/>
Message: <input id="messageInput" type="text" size="64"/> 
<input id="sendButton" type="submit" value="Send"/>
<input id="closeButton" type="submit" value="Close"/>
</div>
<div id="output"></div>

</html> '
! !

!PokerPlayerJS class methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/7/2013 00:09'!
tableID: id
	^(self new tableID: id)! !

!PokerPlayerJS methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/7/2013 00:19'!
renderContentOn: html
	html text: 'Welcome to table ', tableID.
	html horizontalRule.
	
	html form: [ 
		html submitButton
			id: 'hello';
			with: 'Say Hello'. ].
	
	html unorderedList 
		id: 'chatLog'.
		
	self renderJavaScriptOn: html.! !

!PokerPlayerJS methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/7/2013 00:24'!
renderJavaScriptOn: html
	html script: '
var conn = {};
var log = document.getElementById("chatLog");
var helloButton = document.getElementById("hello");
var form = helloButton.form;
 
    conn = new WebSocket("ws://localhost:', (ZnServer default port), '/', tableID, '");
 
    conn.onmessage = function (event) {
      log.innerHTML = "<li>" + event.data + "</li>" + log.innerHTML;
    };
    
    conn.onclose = function (event) {
	console.log("connection closed")
    };

	form.addEventListener("submit", function (event) {
		event.preventDefault();
		if (conn.readyState === 1) {
			conn.send("Hello");      
		}
	}, false);
'! !

!PokerPlayerJS methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/7/2013 00:09'!
tableID: id
	tableID := id.
	! !

WAComponent subclass: #ProjectLanding
	instanceVariableNames: ''
	classVariableNames: 'tables'
	poolDictionaries: ''
	category: 'CS528-Project'!

ProjectLanding class
	instanceVariableNames: 'tables'!

!ProjectLanding commentStamp: '<historical>' prior: 0!
A ProjectLanding is a Seaside component that renders a page which allows users to create or join tables for hosting/playing poker games.

Instance Variables
	tables:		<Object>

tables
	- a dictionary of all active tables. key (tableID) maps to PokerTable object.
!

ProjectLanding class
	instanceVariableNames: 'tables'!

!ProjectLanding class methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/5/2013 22:42'!
canBeRoot
	^ true! !

!ProjectLanding class methodsFor: 'testing' stamp: 'BrianDentino 7/14/2013 15:20'!
initialize 
	"ProjectLanding initialize"
	
	(WAAdmin register: self asApplicationAt: 'landing')
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQCupertinoTheme.
	tables := Dictionary new.! !

!ProjectLanding class methodsFor: 'testing' stamp: 'BrianDentino 7/12/2013 01:00'!
tables
	^tables.! !

!ProjectLanding methodsFor: 'setup' stamp: 'BrianDentino 7/12/2013 01:00'!
createNewTable
	| id |
	id := self request: 'Enter a Table ID:'.
	(ProjectLanding tables) at: id put: (PokerTable id: id).
	self joinTable: id.! !

!ProjectLanding methodsFor: 'initialization' stamp: 'BrianDentino 7/12/2013 00:57'!
initialize 
	super initialize.! !

!ProjectLanding methodsFor: 'setup' stamp: 'BrianDentino 7/12/2013 01:06'!
joinExistingTable
	| id |
	id := self requestTableID.
	self joinTable: id.
	! !

!ProjectLanding methodsFor: 'setup' stamp: 'BrianDentino 7/12/2013 02:16'!
joinTable: tableID
	self call: (PokerPlayer tableID: tableID).
	! !

!ProjectLanding methodsFor: 'rendering' stamp: 'BrianDentino 7/14/2013 14:49'!
renderContentOn: html
	html heading: 'Welcome to Smalltalk Casino!!'.
	html anchor
		callback: [ self createNewTable. ];
		with: 'Start a table'.
	html space.
	html anchor
		callback: [ self joinExistingTable. ];
		with: 'Join a table'.! !

!ProjectLanding methodsFor: 'setup' stamp: 'BrianDentino 7/6/2013 02:09'!
requestTableID
	| id |
	id := self request: 'Enter a Table ID:'.
	^id! !

!ProjectLanding methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/5/2013 22:46'!
states
	^ Array with: self.! !

WAComponent subclass: #SUAjaxTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project'!

!SUAjaxTest commentStamp: '<historical>' prior: 0!
A SUAjaxTest is a simple component I created to explore AJAX capabilities using the Scriptaculous/Prototype libraries.

Instance Variables

!

!SUAjaxTest methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/13/2013 00:43'!
renderContentOn: html
	html div id: 'div_'.
	
	html submitButton onClick: 
		(html updater 
			callback: [ :renderer | self halt. ]);
		with: 'Test'.! !

WAComponent subclass: #TestJSComponent
	instanceVariableNames: 'wsAddress id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project'!

!TestJSComponent commentStamp: '<historical>' prior: 0!
A TestJSComponent is a simple Seaside component that establishes a websocket connection between the rendering browser and a websocket server at the address held in wsAddress.

Instance Variables
	wsAddress:		<string>

wsAddress
	- string representation of the websocket address
	i.e. 'ws://10.0.0.3:8888/client'
!

!TestJSComponent class methodsFor: 'initialize' stamp: 'BrianDentino 7/11/2013 19:51'!
wsAddress: address
	^ (self new) wsAddress: address.! !

!TestJSComponent methodsFor: 'accessing' stamp: 'BrianDentino 7/12/2013 20:00'!
id
	^id! !

!TestJSComponent methodsFor: 'accessing' stamp: 'BrianDentino 7/12/2013 20:00'!
initialize
	super initialize.
	id := 'websocket'! !

!TestJSComponent methodsFor: 'accessing' stamp: 'lb 7/13/2013 14:06'!
renderContentOn: html

	html script: '	
	var conn = {};
	conn = new WebSocket("', wsAddress, '");
 
	conn.onmessage = function (event) {
	
		var json = event.data;
		var obj = JSON.parse(json); /** TODOhow to get jquery to work?? */
		
		console.log(obj.id);
		console.log(obj.content);
		
		var elt = document.getElementById(obj.id);
		elt.innerHTML = obj.content;
    	};
    
    	conn.onclose = function (event) {
		console.log("connection closed")
    	};
	
'! !

!TestJSComponent methodsFor: 'accessing' stamp: 'BrianDentino 7/11/2013 19:52'!
wsAddress
	^wsAddress! !

!TestJSComponent methodsFor: 'accessing' stamp: 'BrianDentino 7/11/2013 19:52'!
wsAddress: address
	wsAddress := address.! !

Object subclass: #BrowserWebsocket
	instanceVariableNames: 'delegate websocket lock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project'!

!BrowserWebsocket commentStamp: '<historical>' prior: 0!
A BrowserWebsocket is an abstraction over the websocket connection between a client PokerPlayer and the browser rendering it.

Instance Variables
	delegate:		<Object>

delegate
	- xxxxx
!

!BrowserWebsocket class methodsFor: 'initialize' stamp: 'BrianDentino 7/11/2013 22:20'!
delegate: aDelegate 
	^(self new delegate: aDelegate).! !

!BrowserWebsocket methodsFor: 'initialize-release' stamp: 'BrianDentino 7/11/2013 22:20'!
delegate: aDelegate
	delegate := aDelegate.! !

!BrowserWebsocket methodsFor: 'initialize-release' stamp: 'BrianDentino 7/12/2013 00:05'!
initialize
	lock := Mutex new.! !

!BrowserWebsocket methodsFor: 'initialize-release' stamp: 'lb 7/12/2013 16:25'!
sendMessage: aMessage
	websocket isNil ifTrue: [ Transcript show: 'browser websocket not ready yet...' ]
		ifFalse: [ websocket sendMessage: aMessage ].! !

!BrowserWebsocket methodsFor: 'initialize-release' stamp: 'BrianDentino 7/13/2013 15:49'!
value: aWebsocket 
	websocket := aWebsocket.
	
	lock critical: [ delegate 
		onMessage: ((WebsocketMessage id: 'Joining' content:  (delegate playerID)) json) 
		from: self. ].
		
	[ websocket runWith: [ :message |
		websocket log info: [
			 'PokerPlayer received message from browser: ', message printString. 
		].
		lock critical: [ delegate onMessage: message from: self. ].
	]. ]
	on: ConnectionClosed 
	do: [ 
		websocket log debug: '**Connection close, cleaning up'.
		delegate close.
	].! !

!BrowserWebsocket methodsFor: 'as yet unclassified' stamp: 'lb 7/12/2013 13:42'!
websocket
^ websocket! !

Object subclass: #PokerTable
	instanceVariableNames: 'id websockets lock players'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project'!

!PokerTable commentStamp: '<historical>' prior: 0!
A PokerTable is a container for clients playing poker together. Each client is represented by a websocket. When the game state is updated, the table broadcasts updates to each of the clients.

Instance Variables
!

!PokerTable class methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/6/2013 20:06'!
id: anIdentifier 
	^ PokerTable new id: anIdentifier.! !

!PokerTable methodsFor: 'websocket' stamp: 'BrianDentino 7/6/2013 21:49'!
broadcast: aMessage
	"Send message to all connected clients"
	lock critical: [ 
		websockets do: [  :each |
			[ each sendMessage: aMessage ]
				on: NetworkError
				do: [  :exception | 
					each log debug: [ exception printString, ' NetworkError in broadcast...ignoring' ] ] ] ]! !

!PokerTable methodsFor: 'protocol' stamp: 'BrianDentino 7/12/2013 00:18'!
clear
	websockets do: [ :each | self unregister: each ].! !

!PokerTable methodsFor: 'accessing' stamp: 'BrianDentino 7/6/2013 18:50'!
id
	^id! !

!PokerTable methodsFor: 'accessing' stamp: 'BrianDentino 7/11/2013 23:27'!
id: anIdentifier 
	id := anIdentifier.
	ZnServer default delegate map: id to: (ZnWebSocketDelegate map: id to: self).! !

!PokerTable methodsFor: 'initialize-release' stamp: 'lb 7/12/2013 16:13'!
initialize 
	websockets := OrderedCollection new.
	players := OrderedCollection new.
	lock := Mutex new.! !

!PokerTable methodsFor: 'accessing' stamp: 'lb 7/13/2013 14:10'!
playersMessage

	| stream |	
	stream := String new writeStream.
	stream nextPutAll: '<ul>'.
	players do: [ :playerID | stream nextPutAll: '<li>', playerID, '</li>' ].
	stream nextPutAll: '</ul>'.
	
	^ (WebsocketMessage id: 'players' content: stream contents) json! !

!PokerTable methodsFor: 'protocol' stamp: 'lb 7/12/2013 13:00'!
register: clientWebSocket
	lock critical: [ 
		websockets add: clientWebSocket ].! !

!PokerTable methodsFor: 'protocol' stamp: 'BrianDentino 7/12/2013 02:06'!
unregister: clientWebSocket
	lock critical: [ 
		websockets remove: clientWebSocket ifAbsent: [ ] ] .
	(websockets size = 0) ifTrue: [ProjectLanding tables removeKey: id]! !

!PokerTable methodsFor: 'protocol' stamp: 'lb 7/13/2013 15:24'!
value: websocket

	| msg broadcastMessage |

	[ self register: websocket.
		websocket runWith: [ :message |
			
			websocket log info: [ 'PokerTable received message: ', message printString ].
			
			broadcastMessage := message.
			
			msg := WebsocketMessage json: message.

			Transcript show: '*******'; show: msg id; show: msg content.
			
			(msg id = 'Joining') 
				ifTrue: [ players add: msg content.
						broadcastMessage := self playersMessage ].
		
		 	self broadcast: broadcastMessage.
			
		].
			
	]
	on: ConnectionClosed 
	do: [ 
		websocket log debug: '!!!!Connection close, cleaning up'.
		self unregister: websocket ].! !

Object subclass: #WebsocketMessage
	instanceVariableNames: 'id content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project'!

!WebsocketMessage commentStamp: '<historical>' prior: 0!
A WebsocketMessage is an object intended to represent a websocket message. It contains an id, so the receiver can identify the type of message, as well as content.

Instance Variables
	content:		<string>
	id:		<string>

content
	- String intended to be interpreted as the content of the message

id
	- String intented to be interpreted as the message identifier.
!

!WebsocketMessage class methodsFor: 'creation' stamp: 'lb 7/13/2013 14:05'!
id: aStringId content: aStringContent 
	^ (self new id: aStringId) content: aStringContent.! !

!WebsocketMessage class methodsFor: 'as yet unclassified' stamp: 'lb 7/13/2013 15:08'!
json: aJsonString

	 |obj |
	
	obj := Json readFrom: (ReadStream on: aJsonString).

	^ WebsocketMessage id: obj id content: obj content! !

!WebsocketMessage methodsFor: 'accessing' stamp: 'BrianDentino 7/12/2013 19:56'!
content
	^content.! !

!WebsocketMessage methodsFor: 'accessing' stamp: 'lb 7/13/2013 14:05'!
content: aString 
	content := aString.! !

!WebsocketMessage methodsFor: 'accessing' stamp: 'BrianDentino 7/12/2013 19:56'!
id
	^id.! !

!WebsocketMessage methodsFor: 'accessing' stamp: 'lb 7/13/2013 14:05'!
id: aString 
	id := aString.! !

!WebsocketMessage methodsFor: 'accessing' stamp: 'lb 7/13/2013 15:05'!
json

	^ Json render: self! !

!WebsocketMessage methodsFor: 'as yet unclassified' stamp: 'lb 7/13/2013 15:07'!
jsonWriteOn: aWriteStream
	
	aWriteStream nextPutAll: '{ "id" : "'.
	aWriteStream nextPutAll: id.
	aWriteStream nextPutAll: '", "content" : "'.
	aWriteStream nextPutAll: content.
	aWriteStream nextPutAll: '" }'.
	^ aWriteStream contents! !

ZnWebSocket subclass: #TableWebsocket
	instanceVariableNames: 'tableID delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528-Project'!

!TableWebsocket commentStamp: '<historical>' prior: 0!
A TableWebsocket is an abstraction over the websocket connection between a PokerPlayer and the PokerTable they are currently a member of. It is a reference maintained by the PokerPlayer so that 

Instance Variables
	delegate:		<PokerPlayer>
	tableID:		<string>

delegate
	- PokerPlayer which will be required to handle incoming messages on this websocket. Must implement onMessage: message.

tableID
	- string representing the ID of the table this websocket is connected to.
!

!TableWebsocket class methodsFor: 'initialize' stamp: 'BrianDentino 7/11/2013 21:45'!
tableID: id delegate: aDelegate 
	^ ((TableWebsocket to: 'ws://localhost:', ZnServer default port asString, '/', id) tableID: id) delegate: aDelegate.! !

!TableWebsocket methodsFor: 'initialize-release' stamp: 'BrianDentino 7/12/2013 02:05'!
delegate: aDelegate
	delegate := aDelegate.
	[[self runWith: [ :message |
      	self crLog: 'PokerPlayer received message from table: ', message printString. 
		delegate onMessage: message from: self].] on: ConnectionClosed do: (self log debug: '==Connection Closed')] fork.! !

!TableWebsocket methodsFor: 'as yet unclassified' stamp: 'BrianDentino 7/11/2013 23:08'!
initialize
	super initialize.
	self role: #server.! !

!TableWebsocket methodsFor: 'initialize-release' stamp: 'BrianDentino 7/6/2013 22:24'!
tableID: id
	tableID := id! !
ProjectLanding initialize!
PokerPlayer initialize!
